/**
 * DevExtreme (cjs/renovation/ui/grids/data_grid_light/widgets/data_row.js)
 * Version: 22.1.0 (build 21357-0315)
 * Build date: Thu Dec 23 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.viewFunction = exports.DataRowProps = exports.DataRow = void 0;
var _inferno = require("inferno");
var _inferno2 = require("@devextreme/runtime/inferno");
var _excluded = ["columns", "data", "rowIndex"];

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) {
            descriptor.writable = true
        }
        Object.defineProperty(target, descriptor.key, descriptor)
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) {
        _defineProperties(Constructor.prototype, protoProps)
    }
    if (staticProps) {
        _defineProperties(Constructor, staticProps)
    }
    Object.defineProperty(Constructor, "prototype", {
        writable: false
    });
    return Constructor
}

function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    _setPrototypeOf(subClass, superClass)
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}
var viewFunction = function(viewModel) {
    return (0, _inferno.createVNode)(1, "tr", "dx-row dx-data-row dx-column-lines", viewModel.cellTexts.map((function(text, index) {
        return (0, _inferno.createVNode)(1, "td", null, text, 0, {
            "aria-selected": "false",
            role: "gridcell"
        }, index)
    })), 0, {
        role: "row",
        "aria-selected": "false"
    })
};
exports.viewFunction = viewFunction;
var DataRowProps = Object.defineProperties({
    rowIndex: 0
}, {
    data: {
        get: function() {
            return {}
        },
        configurable: true,
        enumerable: true
    },
    columns: {
        get: function() {
            return []
        },
        configurable: true,
        enumerable: true
    }
});
exports.DataRowProps = DataRowProps;
var DataRow = function(_BaseInfernoComponent) {
    _inheritsLoose(DataRow, _BaseInfernoComponent);

    function DataRow(props) {
        var _this;
        _this = _BaseInfernoComponent.call(this, props) || this;
        _this.state = {};
        _this.__getterCache = {};
        return _this
    }
    var _proto = DataRow.prototype;
    _proto.componentWillUpdate = function(nextProps, nextState, context) {
        if (this.props.columns !== nextProps.columns || this.props.data !== nextProps.data) {
            this.__getterCache.cellTexts = void 0
        }
    };
    _proto.render = function() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            cellTexts: this.cellTexts,
            restAttributes: this.restAttributes
        })
    };
    _createClass(DataRow, [{
        key: "cellTexts",
        get: function() {
            var _this2 = this;
            if (void 0 !== this.__getterCache.cellTexts) {
                return this.__getterCache.cellTexts
            }
            return this.__getterCache.cellTexts = (_this2$props = _this2.props, columns = _this2$props.columns, data = _this2$props.data, columns.map((function(dataField) {
                return String(data[dataField])
            })));
            var _this2$props, columns, data
        }
    }, {
        key: "restAttributes",
        get: function() {
            var _this$props = this.props,
                restProps = (_this$props.columns, _this$props.data, _this$props.rowIndex, _objectWithoutProperties(_this$props, _excluded));
            return restProps
        }
    }]);
    return DataRow
}(_inferno2.BaseInfernoComponent);
exports.DataRow = DataRow;
DataRow.defaultProps = DataRowProps;
