/**
 * DevExtreme (cjs/renovation/ui/grids/data_grid_light/widgets/paging.js)
 * Version: 22.1.0 (build 21357-0315)
 * Build date: Thu Dec 23 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.viewFunction = exports.PagingProps = exports.PagingPlugin = exports.Paging = void 0;
var _inferno = require("inferno");
var _inferno2 = require("@devextreme/runtime/inferno");
var _context = require("../../../../utils/plugin/context");
var _data_grid_light = require("../data_grid_light");
var _excluded = ["defaultPageIndex", "defaultPageSize", "enabled", "pageIndex", "pageIndexChange", "pageSize", "pageSizeChange"];

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) {
            descriptor.writable = true
        }
        Object.defineProperty(target, descriptor.key, descriptor)
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) {
        _defineProperties(Constructor.prototype, protoProps)
    }
    if (staticProps) {
        _defineProperties(Constructor, staticProps)
    }
    Object.defineProperty(Constructor, "prototype", {
        writable: false
    });
    return Constructor
}

function _assertThisInitialized(self) {
    if (void 0 === self) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called")
    }
    return self
}

function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    _setPrototypeOf(subClass, superClass)
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}
var viewFunction = function() {
    return (0, _inferno.createFragment)()
};
exports.viewFunction = viewFunction;
var PagingProps = {
    enabled: true,
    defaultPageSize: 20,
    pageSizeChange: function() {},
    defaultPageIndex: 0,
    pageIndexChange: function() {}
};
exports.PagingProps = PagingProps;
var PagingPlugin = (0, _context.createValue)();
exports.PagingPlugin = PagingPlugin;
var Paging = function(_InfernoComponent) {
    _inheritsLoose(Paging, _InfernoComponent);

    function Paging(props) {
        var _this;
        _this = _InfernoComponent.call(this, props) || this;
        _this.state = {
            dataSource: [],
            pageSize: void 0 !== _this.props.pageSize ? _this.props.pageSize : _this.props.defaultPageSize,
            pageIndex: void 0 !== _this.props.pageIndex ? _this.props.pageIndex : _this.props.defaultPageIndex
        };
        _this.addPagingHandler = _this.addPagingHandler.bind(_assertThisInitialized(_this));
        _this.updatePagingProps = _this.updatePagingProps.bind(_assertThisInitialized(_this));
        _this.setPageIndex = _this.setPageIndex.bind(_assertThisInitialized(_this));
        _this.setPageSize = _this.setPageSize.bind(_assertThisInitialized(_this));
        _this.calculateVisibleItems = _this.calculateVisibleItems.bind(_assertThisInitialized(_this));
        return _this
    }
    var _proto = Paging.prototype;
    _proto.createEffects = function() {
        return [new _inferno2.InfernoEffect(this.addPagingHandler, [this.plugins, this.props.enabled, this.state.pageSize, this.props.pageSize, this.state.pageIndex, this.props.pageIndex]), new _inferno2.InfernoEffect(this.updatePagingProps, [this.plugins, this.state.pageIndex, this.props.pageIndex, this.props.pageIndexChange, this.state.pageSize, this.props.pageSize, this.props.pageSizeChange, this.state.dataSource])]
    };
    _proto.updateEffects = function() {
        var _this$_effects$, _this$_effects$2;
        null === (_this$_effects$ = this._effects[0]) || void 0 === _this$_effects$ ? void 0 : _this$_effects$.update([this.plugins, this.props.enabled, this.state.pageSize, this.props.pageSize, this.state.pageIndex, this.props.pageIndex]);
        null === (_this$_effects$2 = this._effects[1]) || void 0 === _this$_effects$2 ? void 0 : _this$_effects$2.update([this.plugins, this.state.pageIndex, this.props.pageIndex, this.props.pageIndexChange, this.state.pageSize, this.props.pageSize, this.props.pageSizeChange, this.state.dataSource])
    };
    _proto.addPagingHandler = function() {
        var _this2 = this;
        return this.plugins.extend(_data_grid_light.VisibleItems, 1, (function(items) {
            _this2.setState((function(__state_argument) {
                return {
                    dataSource: items
                }
            }));
            return _this2.calculateVisibleItems(items)
        }))
    };
    _proto.updatePagingProps = function() {
        this.plugins.set(PagingPlugin, {
            pageIndex: void 0 !== this.props.pageIndex ? this.props.pageIndex : this.state.pageIndex,
            setPageIndex: this.setPageIndex,
            pageSize: this.pageSize,
            setPageSize: this.setPageSize,
            totalCount: this.totalCount,
            pageCount: this.pageCount
        })
    };
    _proto.setPageIndex = function(pageIndex) {
        var __newValue;
        this.setState((function(__state_argument) {
            __newValue = pageIndex;
            return {
                pageIndex: __newValue
            }
        }));
        this.props.pageIndexChange(__newValue)
    };
    _proto.setPageSize = function(pageSize) {
        var __newValue;
        this.setState((function(__state_argument) {
            __newValue = pageSize;
            return {
                pageSize: __newValue
            }
        }));
        this.props.pageSizeChange(__newValue)
    };
    _proto.calculateVisibleItems = function(dataSource) {
        if (!this.props.enabled || "all" === this.pageSize) {
            return dataSource
        }
        var start = (void 0 !== this.props.pageIndex ? this.props.pageIndex : this.state.pageIndex) * this.pageSize;
        var end = start + this.pageSize;
        return dataSource.slice(start, end)
    };
    _proto.render = function() {
        this.props;
        return viewFunction()
    };
    _createClass(Paging, [{
        key: "plugins",
        get: function() {
            if ("PluginsContext" in this.context) {
                return this.context.PluginsContext
            }
            return _context.PluginsContext
        }
    }, {
        key: "totalCount",
        get: function() {
            return this.state.dataSource.length
        }
    }, {
        key: "pageCount",
        get: function() {
            if ("all" === this.pageSize) {
                return 1
            }
            return Math.ceil(this.totalCount / this.pageSize)
        }
    }, {
        key: "pageSize",
        get: function() {
            if (0 === (void 0 !== this.props.pageSize ? this.props.pageSize : this.state.pageSize)) {
                return "all"
            }
            return void 0 !== this.props.pageSize ? this.props.pageSize : this.state.pageSize
        }
    }, {
        key: "restAttributes",
        get: function() {
            var _this$props$pageSize$ = _extends({}, this.props, {
                    pageSize: void 0 !== this.props.pageSize ? this.props.pageSize : this.state.pageSize,
                    pageIndex: void 0 !== this.props.pageIndex ? this.props.pageIndex : this.state.pageIndex
                }),
                restProps = (_this$props$pageSize$.defaultPageIndex, _this$props$pageSize$.defaultPageSize, _this$props$pageSize$.enabled, _this$props$pageSize$.pageIndex, _this$props$pageSize$.pageIndexChange, _this$props$pageSize$.pageSize, _this$props$pageSize$.pageSizeChange, _objectWithoutProperties(_this$props$pageSize$, _excluded));
            return restProps
        }
    }]);
    return Paging
}(_inferno2.InfernoComponent);
exports.Paging = Paging;
Paging.defaultProps = PagingProps;
