/**
 * DevExtreme (esm/renovation/ui/grids/data_grid_light/data_grid_light.js)
 * Version: 22.1.0 (build 21357-0315)
 * Build date: Thu Dec 23 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["accessKey", "activeStateEnabled", "children", "className", "columns", "dataSource", "disabled", "focusStateEnabled", "height", "hint", "hoverStateEnabled", "onClick", "onKeyDown", "rtlEnabled", "tabIndex", "visible", "width"];
import {
    createVNode,
    createComponentVNode,
    normalizeProps
} from "inferno";
import {
    InfernoEffect,
    InfernoWrapperComponent
} from "@devextreme/runtime/inferno";
import {
    createGetter,
    Plugins
} from "../../../utils/plugin/context";
import {
    Widget
} from "../../common/widget";
import {
    BaseWidgetProps
} from "../../common/base_props";
import {
    TableContent
} from "./views/table_content";
import {
    TableHeader
} from "./views/table_header";
import {
    Footer
} from "./views/footer";
export var VisibleItems = createGetter([]);
export var viewFunction = viewModel => normalizeProps(createComponentVNode(2, Widget, _extends({
    accessKey: viewModel.props.accessKey,
    activeStateEnabled: viewModel.props.activeStateEnabled,
    aria: viewModel.aria,
    disabled: viewModel.props.disabled,
    focusStateEnabled: viewModel.props.focusStateEnabled,
    height: viewModel.props.height,
    hint: viewModel.props.hint,
    hoverStateEnabled: viewModel.props.hoverStateEnabled,
    rtlEnabled: viewModel.props.rtlEnabled,
    tabIndex: viewModel.props.tabIndex,
    visible: viewModel.props.visible,
    width: viewModel.props.width
}, viewModel.restAttributes, {
    children: createVNode(1, "div", "dx-datagrid dx-gridbase-container", [createComponentVNode(2, TableHeader, {
        columns: viewModel.props.columns
    }), createComponentVNode(2, TableContent, {
        columns: viewModel.props.columns,
        dataSource: viewModel.visibleItems
    }), createComponentVNode(2, Footer), viewModel.props.children], 0, {
        role: "grid",
        "aria-label": "Data grid"
    })
})));
export var DataGridLightProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(BaseWidgetProps), Object.getOwnPropertyDescriptors({
    get dataSource() {
        return []
    },
    get columns() {
        return []
    }
})));
var aria = {
    role: "presentation"
};
import {
    createReRenderEffect
} from "@devextreme/runtime/inferno";
export class DataGridLight extends InfernoWrapperComponent {
    constructor(props) {
        super(props);
        this.plugins = new Plugins;
        this.state = {
            visibleItems: []
        };
        this.updateVisibleItems = this.updateVisibleItems.bind(this);
        this.setDataSourceToVisibleItems = this.setDataSourceToVisibleItems.bind(this)
    }
    createEffects() {
        return [new InfernoEffect(this.updateVisibleItems, [this.plugins]), new InfernoEffect(this.setDataSourceToVisibleItems, [this.plugins, this.props.dataSource]), createReRenderEffect()]
    }
    updateEffects() {
        var _this$_effects$, _this$_effects$2;
        null === (_this$_effects$ = this._effects[0]) || void 0 === _this$_effects$ ? void 0 : _this$_effects$.update([this.plugins]);
        null === (_this$_effects$2 = this._effects[1]) || void 0 === _this$_effects$2 ? void 0 : _this$_effects$2.update([this.plugins, this.props.dataSource])
    }
    getChildContext() {
        return _extends({}, this.context, {
            PluginsContext: this.plugins
        })
    }
    updateVisibleItems() {
        return this.plugins.watch(VisibleItems, items => {
            this.setState(__state_argument => ({
                visibleItems: items
            }))
        })
    }
    setDataSourceToVisibleItems() {
        return this.plugins.extend(VisibleItems, -1, () => this.props.dataSource)
    }
    get aria() {
        return aria
    }
    get restAttributes() {
        var _this$props = this.props,
            restProps = _objectWithoutPropertiesLoose(_this$props, _excluded);
        return restProps
    }
    render() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            visibleItems: this.state.visibleItems,
            plugins: this.plugins,
            aria: this.aria,
            restAttributes: this.restAttributes
        })
    }
}
DataGridLight.defaultProps = DataGridLightProps;
