/**
 * DevExtreme (esm/renovation/ui/grids/data_grid_light/widgets/data_row.js)
 * Version: 22.1.0 (build 21357-0315)
 * Build date: Thu Dec 23 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["columns", "data", "rowIndex"];
import {
    createVNode
} from "inferno";
import {
    BaseInfernoComponent
} from "@devextreme/runtime/inferno";
export var viewFunction = viewModel => createVNode(1, "tr", "dx-row dx-data-row dx-column-lines", viewModel.cellTexts.map((text, index) => createVNode(1, "td", null, text, 0, {
    "aria-selected": "false",
    role: "gridcell"
}, index)), 0, {
    role: "row",
    "aria-selected": "false"
});
export var DataRowProps = {
    get data() {
        return {}
    },
    rowIndex: 0,
    get columns() {
        return []
    }
};
export class DataRow extends BaseInfernoComponent {
    constructor(props) {
        super(props);
        this.state = {};
        this.__getterCache = {}
    }
    get cellTexts() {
        if (void 0 !== this.__getterCache.cellTexts) {
            return this.__getterCache.cellTexts
        }
        return this.__getterCache.cellTexts = (() => {
            var {
                columns: columns,
                data: data
            } = this.props;
            return columns.map(dataField => String(data[dataField]))
        })()
    }
    get restAttributes() {
        var _this$props = this.props,
            restProps = _objectWithoutPropertiesLoose(_this$props, _excluded);
        return restProps
    }
    componentWillUpdate(nextProps, nextState, context) {
        if (this.props.columns !== nextProps.columns || this.props.data !== nextProps.data) {
            this.__getterCache.cellTexts = void 0
        }
    }
    render() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            cellTexts: this.cellTexts,
            restAttributes: this.restAttributes
        })
    }
}
DataRow.defaultProps = DataRowProps;
