/**
 * DevExtreme (esm/renovation/utils/plugin/placeholder_item.js)
 * Version: 22.1.0 (build 21357-0315)
 * Build date: Thu Dec 23 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["children", "column", "componentTypes", "index"];
import {
    createFragment,
    createComponentVNode
} from "inferno";
import {
    Fragment
} from "inferno";
import {
    BaseInfernoComponent
} from "@devextreme/runtime/inferno";
export var viewFunction = _ref => {
    var {
        currentComponent: currentComponent,
        props: {
            children: children,
            column: column,
            componentTypes: componentTypes,
            index: index
        }
    } = _ref;
    return createFragment(currentComponent ? currentComponent(column, createComponentVNode(2, PlaceholderItem, {
        componentTypes: componentTypes,
        column: column,
        index: index + 1,
        children: children
    })) : createFragment(children, 0), 0)
};
export var PlaceholderItemProps = {
    get componentTypes() {
        return []
    },
    index: 0
};
export class PlaceholderItem extends BaseInfernoComponent {
    constructor(props) {
        super(props);
        this.state = {}
    }
    get currentComponent() {
        return this.props.componentTypes[this.props.index]
    }
    get restAttributes() {
        var _this$props = this.props,
            restProps = _objectWithoutPropertiesLoose(_this$props, _excluded);
        return restProps
    }
    render() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            currentComponent: this.currentComponent,
            restAttributes: this.restAttributes
        })
    }
}
PlaceholderItem.defaultProps = PlaceholderItemProps;
