/**
 * DevExtreme (renovation/utils/plugin/placeholder_item.js)
 * Version: 22.1.0 (build 21357-0315)
 * Build date: Thu Dec 23 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.viewFunction = exports.PlaceholderItemProps = exports.PlaceholderItem = void 0;
var _inferno = require("inferno");
var _inferno2 = require("@devextreme/runtime/inferno");
var _excluded = ["children", "column", "componentTypes", "index"];

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) {
            descriptor.writable = true
        }
        Object.defineProperty(target, descriptor.key, descriptor)
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) {
        _defineProperties(Constructor.prototype, protoProps)
    }
    if (staticProps) {
        _defineProperties(Constructor, staticProps)
    }
    Object.defineProperty(Constructor, "prototype", {
        writable: false
    });
    return Constructor
}

function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    _setPrototypeOf(subClass, superClass)
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}
var viewFunction = function(_ref) {
    var currentComponent = _ref.currentComponent,
        _ref$props = _ref.props,
        children = _ref$props.children,
        column = _ref$props.column,
        componentTypes = _ref$props.componentTypes,
        index = _ref$props.index;
    return (0, _inferno.createFragment)(currentComponent ? currentComponent(column, (0, _inferno.createComponentVNode)(2, PlaceholderItem, {
        componentTypes: componentTypes,
        column: column,
        index: index + 1,
        children: children
    })) : (0, _inferno.createFragment)(children, 0), 0)
};
exports.viewFunction = viewFunction;
var PlaceholderItemProps = Object.defineProperties({
    index: 0
}, {
    componentTypes: {
        get: function() {
            return []
        },
        configurable: true,
        enumerable: true
    }
});
exports.PlaceholderItemProps = PlaceholderItemProps;
var PlaceholderItem = function(_BaseInfernoComponent) {
    _inheritsLoose(PlaceholderItem, _BaseInfernoComponent);

    function PlaceholderItem(props) {
        var _this;
        _this = _BaseInfernoComponent.call(this, props) || this;
        _this.state = {};
        return _this
    }
    var _proto = PlaceholderItem.prototype;
    _proto.render = function() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            currentComponent: this.currentComponent,
            restAttributes: this.restAttributes
        })
    };
    _createClass(PlaceholderItem, [{
        key: "currentComponent",
        get: function() {
            return this.props.componentTypes[this.props.index]
        }
    }, {
        key: "restAttributes",
        get: function() {
            var _this$props = this.props,
                restProps = (_this$props.children, _this$props.column, _this$props.componentTypes, _this$props.index, _objectWithoutProperties(_this$props, _excluded));
            return restProps
        }
    }]);
    return PlaceholderItem
}(_inferno2.BaseInfernoComponent);
exports.PlaceholderItem = PlaceholderItem;
PlaceholderItem.defaultProps = PlaceholderItemProps;
